#ifndef _p4_h
#define _p4_h

extern int line_dbg;
extern const char* __processor__;
#define L {if (line_dbg) fprintf(stderr,"%s:%s:%d:\n",__processor__,__FILE__,__LINE__);}

#include <ctype.h>
#include <stdio.h>
#include <signal.h>
#include <errno.h>

#if defined(RS6000)  ||  defined(SYMMETRY_PTX)
#include <sys/select.h>
#endif

#ifdef _ICC
#define TRANSPUTER
#endif

#ifdef TRANSPUTER
extern int slave( void );
#include <semaphor.h>
#ifdef SOCKET_SERVER
#include "t_xdr.h"
#include "t_socket.h"
#endif
#else  /* !TRANSPUTER */
/* for xdr  -  includes netinet/in.h and sys/types.h */
#include <rpc/rpc.h>
#include <sys/time.h>
#include <pwd.h>
#include <fcntl.h>
#endif

#include "p4_config.h"
#include "p4_MD.h"
#include "p4_mon.h"
#include "p4_sr.h"

#include "p4_funcs.h"

#ifndef P4_DPRINTFL
#define p4_dprintfl
#endif

#include "alog.h"

#include "usc.h"
#define p4_ustimer() usc_clock()
#define p4_usrollover() usc_MD_rollover_val

#define HOSTNAME_LEN 64
#define RESOURCENAME_LEN 32

struct p4_procgroup_entry {
    char host_name[HOSTNAME_LEN];
    int numslaves_in_group;
    char slave_full_pathname[100];
    char username[10];
};

#define P4_MAX_PROCGROUP_ENTRIES 32
struct p4_procgroup {
    struct p4_procgroup_entry entries[P4_MAX_PROCGROUP_ENTRIES];
    int num_entries;
};

#endif
